RS232 Cable Pinouts
===================

These RS232 data cables have been used during development.
Their pinouts are provided here in the hope they will be useful.

Number 1) and 4) seem to be the best, for they have proper grounding
of _GND_ and _Protective GND_. Usual length of each cable is about 100cm.

@note
- DTE = Data Terminal Equipment (Host)

  This side is using a DB9 plug.

- DCE = Data Communication Equipment (Chipflasher Board)

  This side is using a Header10_2 Connector.

All pin names reflect their function from the host’s point of view (DTE pin labels).
See [cables.sch][] or [cables.sch.png][] for more details.


Pin Functions and Zerocat Connect Usage
---------------------------------------

DTE Function        | DTE pin label | DTE pin | DCE pin | Zerocat Connect Usage (Host)
:-----------        | :------------ | :------ | :------ | ---------------------------:
Carrier Detect      | CD            | 1       | 1       | not used
Data Set Ready      | DSR           | 6       | 2       | not used
Receive Data        | RXD           | 2       | 3       | receive data
Request To Send     | RTS           | 7       | 4       | alternative reset line
Transmit Data       | TXD           | 3       | 5       | transmit data
Clear To Send       | CTS           | 8       | 6       | not used
Data Terminal Ready | DTR           | 4       | 7       | default reset line
Ring Indicator      | RI            | 9       | 8       | not used
Ground              | GND           | 5       | 9       | gnd, power return


1) Black Cable
--------------

DTE pin label               | DTE pin | colour | DCE pin
:------------               | :------ | :----- | ------:
CD                          | 1       | brown  | 1
DSR                         | 6       | grey   | 2
RXD                         | 2       | blue   | 3
RTS                         | 7       | green  | 4
TXD                         | 3       | red    | 5
CTS                         | 8       | yellow | 6
DTR                         | 4       | violet | 7
RI                          | 9       | orange | 8
GND                         | 5       | black  | 9
(GND and PGND) one one side | --      | shield | --


2) Old mouse cable light grey
-----------------------------

DTE pin label | DTE pin | colour | DCE pin
------------: | :------ | :----- | ------:
RXD           | 2       | brown  | 3
RTS           | 7       | white  | 4
TXD           | 3       | orange | 5
DTR           | 4       | green  | 7
GND           | 5       | blue   | 9


3) Old mouse cable dark grey
----------------------------

DTE pin label | DTE pin | colour | DCE pin
------------: | :------ | :----- | ------:
DSR           | 6       | white  | 2
RXD           | 2       | black  | 3
RTS           | 7       | yellow | 4
TXD           | 3       | brown  | 5
DTR           | 4       | red    | 7
GND           | 5       | orange | 9


4) Keyboard cable beige
-----------------------

DTE pin label               | DTE pin | colour | DCE pin
------------:               | :------ | :----- | ------:
RXD                         | 2       | white  | 3
TXD                         | 3       | red    | 5
DTR                         | 4       | green  | 7
GND                         | 5       | yellow | 9
(GND and PGND) on one side  | --      | blank  | --



<!-- Paths are prefixed with ../../../ to make them work for doxygen! -->
[cables.sch.png]:   ../../../generated-images/cables.sch.png
[cables.sch]:       ../../../../hardware/gschem/cables.sch


-----------------------------------------------------------------------

  @copyright
  Copyright (C) 2017, 2018 Kai Mertens <kmx@posteo.net> @n
  Permission is granted to copy, distribute and/or modify this document
  under the terms of the GNU Free Documentation License, Version 1.3
  or any later version published by the Free Software Foundation;
  with no Invariant Sections, no Front-Cover Texts, and no Back-Cover Texts.
  A copy of the license is included in the section entitled:
  [GNU Free Documentation License](COPYING-DOCUMENTATION.md)
