Neighbourhood
=============

  @todo
  Format cites more clearly.

  @todo
  Update information about Teensy.

  @todo
  Add the HiFive1.


Some terms explained
--------------------

- **Microcontroller**

  A microcontroller is a small computer (SoC) on a single integrated
  circuit containing a processor core, memory, and programmable
  input/output peripherals. Program memory in the form of Ferroelectric
  RAM, NOR flash or OTP ROM is also often included on chip, as well as
  a typically small amount of RAM. Microcontrollers are designed for
  embedded applications, in contrast to the microprocessors used in
  personal computers or other general purpose applications.

  [Source][src1]

- **ARM**

  ARM, originally Acorn RISC Machine, is a family of reduced instruction
  set computing (RISC) architectures for computer processors, configured
  for various environments, developed by British company ARM Holdings.

  ARM Holdings _licenses the chip designs_ and the ARM instruction set
  architectures to third parties, who design their own products that
  implement one of those architectures --- including systems-on-chips
  (SoC) that incorporate memory, interfaces, radios, etc.

  While ARM Holdings does not grant the licensee the right to resell
  the ARM architecture itself, licensees may freely sell manufactured
  product such as chip devices, evaluation boards and complete systems.

  ARM Holdings prices its IP (= intellectual property) based on
  perceived value. Lower performing ARM cores typically have lower
  licence costs than higher performing cores. In implementation terms,
  a synthesizable core costs more than a hard macro (blackbox) core.

  [Source][src2]

- **IP-core** (semiconductor intellectual property core)

  In electronic design a semiconductor intellectual property core,
  IP core, or IP block is a reusable unit of logic, cell, or chip
  layout design that is the intellectual property of one party. IP
  cores may be licensed to another party or can be owned and used
  by a single party alone. The term is derived from the licensing
  of the patent and/or source code copyright that exist in the design.

  [Source][src3]

- **Parallax Propeller**

  The Parallax P8X32A Propeller chip, introduced in 2006, is a
  multi-core architecture parallel microcontroller with eight 32-bit
  RISC CPU cores.

  The Parallax Propeller microcontroller, Propeller Assembly language,
  and Spin interpreter were designed by one person, Parallax's
  co-founder and president Chip Gracey. The Spin programming language
  and "Propeller Tool" integrated development environment were designed
  by Chip Gracey and Parallax's software engineer Jeff Martin.

  On August 6, 2014, Parallax Inc. released the Propeller P8X32A
  Verilog and top-level HDL files under the GNU General Public
  License 3.0.

  [Source][src4]

- **Flash memory**

  Flash memory is an electronic non-volatile computer storage medium
  that can be electrically erased and reprogrammed.

  Whereas EPROMs had to be completely erased before being rewritten,
  NAND type flash memory may be written and read in blocks (or pages)
  which are generally much smaller than the entire device. NOR type
  flash allows a single machine word (byte) to be written -- to an
  erased location -- or read independently.

  [Source][src5]


Important People
----------------

- **John L. Hennessy**

  John Leroy Hennessy (born September 22, 1952) is an American computer
  scientist, academician, and businessman. Hennessy is one of the
  founders of MIPS Computer Systems Inc. as well as Atheros and is the
  tenth President of Stanford University. Marc Andreessen called
  him "the godfather of Silicon Valley".

  In 2012, Hennessy was awarded the IEEE Medal of Honor.\[13\] The IEEE
  awarded Hennessy their highest recognition "for pioneering the RISC
  processor architecture and for leadership in computer engineering
  and higher education".

  [Source][src6]

  - [RISC-V Project][]

  - Hennessy & Patterson, book authors;
    Book title: "Computer Architecture, 5th Edition",
    Print Book ISBN: 9780123838728, eBook ISBN: 9780123838735

- **Chip Gracey**, Founder and President of Parallax, developed the
  Propeller microcontroller

  The Propeller microcontroller, and its upcoming successor, are
  designed for use in open-source hardware applications, and
  Parallax’s development boards for the Propeller microcontroller
  are released as open hardware designs.

  _Because Parallax doesn’t require non-disclosure agreements_ to get
  technical information about its products, Chip is able to post
  in-depth information about the next Propeller microcontroller
  while he is working on it, and get immediate feedback.

  [Source][src7]


Flashrom Software
-----------------

flashrom is a utility for identifying, reading, writing, verifying
and erasing flash chips. It is designed to flash
BIOS/EFI/coreboot/firmware/optionROM images on mainboards,
network/graphics/storage controller cards, and various other
programmer devices.

[Source][src8]

Flashrom’s native protocol is [serprog][], but a lot of
[external flashers][flashrom-flashers] are supported.


The Chipflasher and its Neighbours
----------------------------------

- **Zerocat Chipflasher**,
  intends to be a 100% free-design hardware tool
  - started as a support equipment for the [libreboot][] project
  - core: Parallax Propeller free-design chip
  - board: free-design circuit
  - free software tools
  - easy to use
  - Do-it-Yourself hardware

  This flasher runs its own `kick-connect` protocol, but using
  flashrom’s [serprog][] as well would be a very good idea.

- **BeagleBoneBlack** (BBB), a real computer, approx. 50,- Euro?
  - free board design files,
  - free software,
  - System without chip from [TI][], nonfree ARM design
  - nonfree video driver

- **Raspberry Pi** with Broadcom chip
  - nonfee ARM design
  - nonfree video driver and baseband processor
    (wireless communication), controlling the boot process

- **Bus Pirate**
  - nonfree PIC microcontroller
  - nonfree code as well?

- **Teensy**



[src1]:   https://en.wikipedia.org/wiki/Microcontroller
[src2]:   https://en.wikipedia.org/wiki/ARM_architecture
[src3]:   https://en.wikipedia.org/wiki/Semiconductor_intellectual_property_core
[src4]:   https://en.wikipedia.org/wiki/Parallax_Propeller
[src5]:   https://en.wikipedia.org/wiki/Flash_memory
[src6]:   https://en.wikipedia.org/wiki/John_L._Hennessy
[src7]:   https://www.parallax.com/news/2013-10-08/chip-gracey-parallax-founder-talks-open-source-mit
[src8]:   http://www.flashrom.org/Flashrom

[RISC-V Project]:     http://riscv.org/
[libreboot]:          http://www.libreboot.org/
[TI]:                 http://www.ti.com/
[serprog]:            http://www.flashrom.org/Serprog
[flashrom-flashers]:  http://www.flashrom.org/Supported_programmers


-----------------------------------------------------------------------

  @copyright
  Copyright (C) 2016, 2017, 2018 Kai Mertens <kmx@posteo.net> @n
  Permission is granted to copy, distribute and/or modify this document
  under the terms of the GNU Free Documentation License, Version 1.3
  or any later version published by the Free Software Foundation;
  with no Invariant Sections, no Front-Cover Texts, and no Back-Cover Texts.
  A copy of the license is included in the section entitled:
  [GNU Free Documentation License](COPYING-DOCUMENTATION.md)
